<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>propclass/defcam.h Source File (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">propclass/defcam.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    Crystal Space Entity Layer</span>
<a name="l00003"></a>00003 <span class="comment">    Copyright (C) 2001-2005 by Jorrit Tyberghein</span>
<a name="l00004"></a>00004 <span class="comment"></span>
<a name="l00005"></a>00005 <span class="comment">    This library is free software; you can redistribute it and/or</span>
<a name="l00006"></a>00006 <span class="comment">    modify it under the terms of the GNU Library General Public</span>
<a name="l00007"></a>00007 <span class="comment">    License as published by the Free Software Foundation; either</span>
<a name="l00008"></a>00008 <span class="comment">    version 2 of the License, or (at your option) any later version.</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">    This library is distributed in the hope that it will be useful,</span>
<a name="l00011"></a>00011 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00012"></a>00012 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00013"></a>00013 <span class="comment">    Library General Public License for more details.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">    You should have received a copy of the GNU Library General Public</span>
<a name="l00016"></a>00016 <span class="comment">    License along with this library; if not, write to the Free</span>
<a name="l00017"></a>00017 <span class="comment">    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.</span>
<a name="l00018"></a>00018 <span class="comment">*/</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __CEL_PF_DEFAULT_CAMERA__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __CEL_PF_DEFAULT_CAMERA__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;propclass/camera.h&quot;</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="keyword">struct </span><a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>;
<a name="l00026"></a>00026 
<a name="l00055"></a><a class="code" href="structiPcDefaultCamera.html">00055</a> <span class="keyword">struct </span><a class="code" href="structiPcDefaultCamera.html" title="This is a property class that wraps a standard first-person and third-person camera and related funct...">iPcDefaultCamera</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="code" href="structiPcCamera.html" title="The representation of a camera.">iPcCamera</a>
<a name="l00056"></a>00056 {
<a name="l00057"></a>00057   SCF_INTERFACE (<a class="code" href="structiPcDefaultCamera.html" title="This is a property class that wraps a standard first-person and third-person camera and related funct...">iPcDefaultCamera</a>, 0, 0, 3);
<a name="l00058"></a>00058 
<a name="l00062"></a><a class="code" href="structiPcDefaultCamera.html#a53a7f09fa80118f6029c2f65edda315e">00062</a>   <span class="keyword">enum</span> <a class="code" href="structiPcDefaultCamera.html#a53a7f09fa80118f6029c2f65edda315e" title="Camera modes.">CameraMode</a>
<a name="l00063"></a>00063   {
<a name="l00064"></a>00064     freelook = 0,
<a name="l00065"></a>00065     firstperson,
<a name="l00066"></a>00066     thirdperson,
<a name="l00067"></a>00067     m64_thirdperson,
<a name="l00068"></a>00068     lara_thirdperson,
<a name="l00069"></a>00069 
<a name="l00070"></a>00070     actual_data,        <span class="comment">// The actual camera data</span>
<a name="l00071"></a>00071     last_actual,        <span class="comment">// Keep reference to the actual data last frame</span>
<a name="l00072"></a>00072     transition,
<a name="l00073"></a>00073     camerror,           <span class="comment">// Error between actual camera pos and ideal.</span>
<a name="l00074"></a>00074 
<a name="l00075"></a>00075     CameraMode_count
<a name="l00076"></a>00076   };
<a name="l00077"></a>00077 
<a name="l00083"></a>00083   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcDefaultCamera.html#ab5a645969079916bbef46ea364372352" title="Set the destination entity manually.">SetFollowEntity</a> (<a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>* entity) = 0;
<a name="l00084"></a>00084 
<a name="l00088"></a>00088   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiPcDefaultCamera.html#aa18c3d0433532eb9cd64a64ffdf2077a" title="Set camera mode.">SetMode</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/namespaceCS_1_1Utility.html#aad39af309187b12e0aa5151e74f63d89">CameraMode</a> m, <span class="keywordtype">bool</span> use_cd = <span class="keyword">true</span>) = 0;
<a name="l00089"></a>00089 
<a name="l00093"></a>00093   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/namespaceCS_1_1Utility.html#aad39af309187b12e0aa5151e74f63d89">CameraMode</a> <a class="code" href="structiPcDefaultCamera.html#a45976932c411a0e3d6c5a6c2564777ed" title="Get camera mode.">GetMode</a> () <span class="keyword">const</span> = 0;
<a name="l00094"></a>00094 
<a name="l00098"></a>00098   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiPcDefaultCamera.html#ae7a8d0c43513fc75e7fc6362b9efc32c" title="Set camera mode by name.">SetModeName</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* m, <span class="keywordtype">bool</span> use_cd = <span class="keyword">true</span>) = 0;
<a name="l00099"></a>00099 
<a name="l00103"></a>00103   <span class="keyword">virtual</span> <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="structiPcDefaultCamera.html#a85a6e8df8def146e805dc450c665ef7b" title="Get camera mode name.">GetModeName</a> () <span class="keyword">const</span> = 0;
<a name="l00104"></a>00104 
<a name="l00109"></a>00109   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/namespaceCS_1_1Utility.html#aad39af309187b12e0aa5151e74f63d89">CameraMode</a> <a class="code" href="structiPcDefaultCamera.html#ad8e6fc27783dd641f5d9b0dfb3cc65f5" title="Get next possible camera mode.">GetNextMode</a> () <span class="keyword">const</span> = 0;
<a name="l00110"></a>00110 
<a name="l00115"></a>00115   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiPcDefaultCamera.html#a6a501724281f185506af71717d1218a4" title="Point the camera to some given location.">PointCamera</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* start) = 0;
<a name="l00116"></a>00116 
<a name="l00120"></a>00120   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcDefaultCamera.html#a1f5e917c9f0f68a20b19795a92572daf" title="Set spring parameters for the current camera mode.">SetSpringParameters</a> (<span class="keywordtype">float</span> springCoef,
<a name="l00121"></a>00121         <span class="keywordtype">float</span> intertialDampeningCoef, <span class="keywordtype">float</span> springLength) = 0;
<a name="l00122"></a>00122 
<a name="l00128"></a>00128   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcDefaultCamera.html#a523df60e1f635a48e6a594e4659f31a7" title="Set the minimum and maximum distance between camera and player.">SetMinMaxCameraDistance</a> (<span class="keywordtype">float</span> minDistance,
<a name="l00129"></a>00129         <span class="keywordtype">float</span> maxDistance) = 0;
<a name="l00130"></a>00130 
<a name="l00135"></a>00135   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcDefaultCamera.html#aa8a85ff9ca1bfcb62e6b1396dc580717" title="Set the turn speed for the camera.">SetTurnSpeed</a> (<span class="keywordtype">float</span> turnSpeed) = 0;
<a name="l00136"></a>00136 
<a name="l00140"></a>00140   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcDefaultCamera.html#ad7ef8c2f8d1306e8f5b5c487a38fabaf" title="Set the swing coefficient for the camera.">SetSwingCoef</a> (<span class="keywordtype">float</span> swingCoef) = 0;
<a name="l00141"></a>00141 
<a name="l00146"></a>00146   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcDefaultCamera.html#a45f0983e9866a4a1f743eaa00b811d7d" title="Set offset for first person camera (offset for camera relative to player model).">SetFirstPersonOffset</a> (<span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; offset) = 0;
<a name="l00147"></a>00147 
<a name="l00152"></a>00152   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcDefaultCamera.html#aa0f1a274161df1bf511222afae856636" title="Set offset for third person camera (offset for camera relative to player model).">SetThirdPersonOffset</a> (<span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; offset) = 0;
<a name="l00153"></a>00153 
<a name="l00158"></a>00158   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcDefaultCamera.html#ae1d609377426bec83deabeb55054c557" title="Center camera in any mode except first person mode.">CenterCamera</a> () = 0;
<a name="l00159"></a>00159 
<a name="l00163"></a>00163   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcDefaultCamera.html#a8b65bdbf416ca69a76be0e1bc76983aa" title="Control pitch.">SetPitch</a> (<span class="keywordtype">float</span> pitch) = 0;
<a name="l00164"></a>00164 
<a name="l00168"></a>00168   <span class="keyword">virtual</span> <span class="keywordtype">float</span> <a class="code" href="structiPcDefaultCamera.html#a02730a3cbc9e5d99186d2fc76e3aac85" title="Get current pitch.">GetPitch</a> () <span class="keyword">const</span> = 0;
<a name="l00169"></a>00169 
<a name="l00174"></a>00174   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcDefaultCamera.html#a088588c7bcadd6e6ffd2ba681b7fc26e" title="Control velocity of pitch.">SetPitchVelocity</a> (<span class="keywordtype">float</span> pitchVel) = 0;
<a name="l00175"></a>00175 
<a name="l00179"></a>00179   <span class="keyword">virtual</span> <span class="keywordtype">float</span> <a class="code" href="structiPcDefaultCamera.html#afe0dbbe377092218bc0dea78ea7264f8" title="Get current pitch velocity.">GetPitchVelocity</a> () <span class="keyword">const</span> = 0;
<a name="l00180"></a>00180 
<a name="l00187"></a>00187   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcDefaultCamera.html#af510fc23b21feb673317036941742b8f" title="Moves the pitch (up/down) of the camera.">MovePitch</a> (<span class="keywordtype">float</span> deltaPitch, <span class="keywordtype">int</span> mode = -1) = 0;
<a name="l00188"></a>00188 
<a name="l00195"></a>00195   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcDefaultCamera.html#a7a5ae08ed28bb260240525b83e88b056" title="Sets the yaw (left/right) of the camera.">SetYaw</a> (<span class="keywordtype">float</span> yaw, <span class="keywordtype">int</span> mode = -1) = 0;
<a name="l00196"></a>00196 
<a name="l00203"></a>00203   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcDefaultCamera.html#ab08a3f6b62af17063d3c28e58d351903" title="Moves the yaw (left/right) of the camera.">MoveYaw</a> (<span class="keywordtype">float</span> deltaYaw, <span class="keywordtype">int</span> mode = -1) = 0;
<a name="l00204"></a>00204 
<a name="l00211"></a>00211   <span class="keyword">virtual</span> <span class="keywordtype">float</span> <a class="code" href="structiPcDefaultCamera.html#aa5b16c297076a40742fbf624c8d52b4a" title="Returns the yaw (left/right) of the camera.">GetYaw</a> (<span class="keywordtype">int</span> mode = -1) <span class="keyword">const</span> = 0;
<a name="l00212"></a>00212 
<a name="l00217"></a>00217   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcDefaultCamera.html#a8e57412555ea6596a155739a0e652b10" title="Sets the yaw (up/down) velocity of the camera.">SetYawVelocity</a> (<span class="keywordtype">float</span> yawVel) = 0;
<a name="l00218"></a>00218 
<a name="l00223"></a>00223   <span class="keyword">virtual</span> <span class="keywordtype">float</span> <a class="code" href="structiPcDefaultCamera.html#aa2d31e13b58c79196f7df8e3a30b9c00" title="Gets the yaw (up/down) velocity of the camera.">GetYawVelocity</a> () <span class="keyword">const</span> = 0;
<a name="l00224"></a>00224 
<a name="l00230"></a>00230   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcDefaultCamera.html#aa021f6392b9313df925622e8beb0a192" title="Set the distance between the character&#39;s eyes and the camera.">SetDistance</a> (<span class="keywordtype">float</span> distance, <span class="keywordtype">int</span> mode=-1) = 0;
<a name="l00231"></a>00231 
<a name="l00237"></a>00237   <span class="keyword">virtual</span> <span class="keywordtype">float</span> <a class="code" href="structiPcDefaultCamera.html#a21c345e68cd9a29dec9a0e680419d685" title="Get the distance between the character&#39;s eyes and the camera.">GetDistance</a> (<span class="keywordtype">int</span> mode=-1) = 0;
<a name="l00238"></a>00238 
<a name="l00243"></a>00243   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcDefaultCamera.html#afa8a9399df7956da558e5f2b2d73dfbf" title="Sets the distance (zoom) velocity of the camera.">SetDistanceVelocity</a> (<span class="keywordtype">float</span> distanceVel) = 0;
<a name="l00244"></a>00244 
<a name="l00249"></a>00249   <span class="keyword">virtual</span> <span class="keywordtype">float</span> <a class="code" href="structiPcDefaultCamera.html#a4a708428afeb0c396f9057cea909e2f5" title="Gets the distance (zoom) velocity of the camera.">GetDistanceVelocity</a> () <span class="keyword">const</span> = 0;
<a name="l00250"></a>00250 
<a name="l00251"></a>00251 };
<a name="l00252"></a>00252 
<a name="l00253"></a>00253 <span class="preprocessor">#endif // __CEL_PF_DEFAULT_CAMERA_FACTORY__</span>
<a name="l00254"></a>00254 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
